<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_support.php                                        ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/date_functions.php");
	
	check_admin_security("support");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_support.html");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_support_reply_href", "admin_support_reply.php");
	$t->set_var("admin_support_request_href", "admin_support_request.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_support_priorities_href", "admin_support_priorities.php?rp=admin_support.php");
	$t->set_var("admin_support_statuses_href", "admin_support_statuses.php?rp=admin_support.php");
	$t->set_var("admin_support_products_href", "admin_support_products.php?rp=admin_support.php");
	$t->set_var("admin_support_types_href", "admin_support_types.php?rp=admin_support.php");
	$t->set_var("admin_support_settings_href", "admin_support_settings.php");
	$t->set_var("admin_support_predefined_href", "admin_support_predefined.php");        
	$t->set_var("admin_support_departments_href", "admin_support_departments.php");        
	$t->set_var("admin_support_admins_href", "admin_support_admins.php");     
	$t->set_var("admin_support_static_tables_href", "admin_support_departments.php");        


	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_support.php");
	$s->set_default_sorting(7, "desc");
	$s->set_sorter("No", "sorter_id", "1", "support_id");
	$s->set_sorter("Summary", "sorter_summary", "2", "summary");
	$s->set_sorter("Status", "sorter_status", "3", "ss.status_name");
	$s->set_sorter("Type", "sorter_type", "4", "st.type_name");
	$s->set_sorter("Email", "sorter_user", "5", "s.user_email");
	$s->set_sorter("Priority", "sorter_priority", "6", "sp.priority_name");
	$s->set_sorter("Last Updated", "sorter_modified", "7", "s.date_modified");

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_support.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$support_statuses = get_db_values("SELECT * FROM " . $table_prefix . "support_statuses", array(array("", "Any Status")));

	$where = "";
	$r = new VA_Record($table_prefix . "orders");
	$r->add_textbox("s_w", TEXT);
	$r->add_radio("s_s", INTEGER, $support_statuses);
	$r->get_form_parameters();
	$r->set_form_parameters();
	$t->set_var("s_w_url", urlencode($r->get_value("s_w")));
	$t->set_var("s_s_url", urlencode($r->get_value("s_s")));

	if(!$r->is_empty("s_w")) {
		$s_w_sql = $db->tosql($r->get_value("s_w"), TEXT, false);
		$where  = " (s.summary LIKE '%" . $s_w_sql . "%'";
		$where .= " OR s.user_name LIKE '%" . $s_w_sql . "%'";
		$where .= " OR s.user_email LIKE '%" . $s_w_sql . "%')";
	}

	if(!$r->is_empty("s_s")) {
		if(strlen($where)) { $where .= " AND "; }
		$where .= " s.support_status_id=" . $db->tosql($r->get_value("s_s"), INTEGER);
	}

	if(strlen($where)) {
		$where = " WHERE " . $where;
	}


	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "support s " . $where);
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT s.support_id, s.summary, ss.status_name, st.type_name, s.user_email, ";
	$sql .= " sp.priority_name, s.date_modified ";
	$sql .= " FROM (((" . $table_prefix . "support s ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=s.support_status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id=s.support_type_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_priorities sp ON sp.priority_id=s.support_priority_id) ";
	$sql .= $where;
	$sql .= $s->order_by;
	$db->query($sql);
	if($db->next_record())
	{

		$admin_support_reply_url = new VA_URL("admin_support_reply.php", true);
		$admin_support_reply_url->add_parameter("support_id", DB, "support_id");
		$admin_support_request_url = new VA_URL("admin_support_request.php", true);
		$admin_support_request_url->add_parameter("support_id", DB, "support_id");

		$t->set_var("no_records", "");
		$t->parse("sorters", false);
		do
		{
			$t->set_var("support_id", $db->f("support_id"));

			$t->set_var("admin_support_reply_url", $admin_support_reply_url->get_url());
			$t->set_var("admin_support_request_url", $admin_support_request_url->get_url());

			$t->set_var("summary", $db->f("summary"));
			$status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
			$t->set_var("status", $status);
			$t->set_var("type", $db->f("type_name"));
			$t->set_var("user_email", $db->f("user_email"));
//			$priority = strlen($db->f("priority_name")) ? $db->f("priority_name") : "Normal";
			$priority = ($db->f("priority_name")=="High") ? "!" : "";

			$t->set_var("priority", $priority);

			$date_modified = $db->f("date_modified", DATETIME);
			$date_modified_string = va_date($datetime_show_format, $date_modified);
			$t->set_var("date_modified", $date_modified_string);

			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>