<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  block_login.php                                          ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


function login_form($block_name, $block_prefix = "")
{
	global $t;
	global $db, $table_prefix;

	if($block_name) {
	  $t->set_file("block_body", "block_login.html");
	}

	$t->set_var("LOGIN_TITLE",    LOGIN_TITLE);
	$t->set_var("CLICK_HERE_MSG", CLICK_HERE_MSG);

  $t->set_var("user_home_href", "user_home.php");

	$t->set_var("category_id", htmlspecialchars(get_param("category_id")));
	$t->set_var("item_id", htmlspecialchars(get_param("item_id")));
	$t->set_var("search_category_id", htmlspecialchars(get_param("search_category_id")));
	$t->set_var("search_string", htmlspecialchars(get_param("search_string")));

	$login_action = get_param("login_action");
	$login_errors = ""; $user_login = "";
	if(strlen($login_action))
	{
		if($login_action == "logout")
		{
			set_session("session_user_id", "");
			set_session("session_user_login", "");
			set_session("session_user_name", "");
			set_session("session_user_email", "");
		}
		else
		{

			$user_login = get_param("user_login");
			$user_password = get_param("user_password");
			
			if(!strlen($user_login)) {
				$error_message = str_replace("{field_name}", LOGIN_FIELD, REQUIRED_MESSAGE);
				$login_errors .= $error_message . "<br>";
			}
	  
			if(!strlen($user_password)) {
				$error_message = str_replace("{field_name}", PASSWORD_FIELD, REQUIRED_MESSAGE);
				$login_errors .= $error_message . "<br>";
			}
			
			if(!strlen($login_errors))
			{
				$sql  = " SELECT user_id,login,name,first_name,last_name,email FROM " . $table_prefix . "users WHERE ";
				$sql .= " login=" . $db->tosql($user_login, TEXT);
				$sql .= " AND password=" . $db->tosql($user_password, TEXT);
				$db->query($sql);
				if($db->next_record())
				{
					set_session("session_user_id", $db->f("user_id"));
					set_session("session_user_login", $user_login);
					if(strlen($db->f("name"))) {
						$user_name = $db->f("name");
					} else if (strlen($db->f("first_name")) || strlen($db->f("last_name"))) {
						$user_name = $db->f("first_name") . " " . $db->f("last_name");
					} else {
						$user_name = $user_login;
					}
					set_session("session_user_name", $user_name);
					set_session("session_user_email", $db->f("email"));

					header("Location: user_home.php");
					exit;
				}
				else
				{
					$login_errors .= LOGIN_PASSWORD_ERROR . "<br>";
				}
			}
		}
	}

	if(get_session("session_user_id"))	
	{
		$t->set_var("LOGIN_AS_MSG",     LOGIN_AS_MSG);
		$t->set_var("ACCESS_HOME_MSG",  ACCESS_HOME_MSG);
		$t->set_var("LOGOUT_BUTTON",    LOGOUT_BUTTON);

		$t->set_var("user_login", get_session("session_user_login"));
		$t->set_var("user_name", get_session("session_user_name"));
		$t->set_var("login_action", "logout");
		$t->set_var("login_form", "");
		$t->parse($block_prefix . "logout_form", false);
	}
	else
	{
		$t->set_var("LOGIN_FIELD",      LOGIN_FIELD);
		$t->set_var("PASSWORD_FIELD",   PASSWORD_FIELD);
		$t->set_var("GO_BUTTON",        GO_BUTTON);

		$t->set_var("user_login", htmlspecialchars($user_login));
		$t->set_var("login_action", "login");
		$t->set_var("logout_form", "");
		$t->parse($block_prefix . "login_form", false);
	}

	if(strlen($login_errors))
	{
		$t->set_var("errors_list", $login_errors);
		$t->parse($block_prefix . "login_errors", false);
	}

	if($block_name) {
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>