<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  forum.php                                                ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include("./includes/sorter.php");
	include("./includes/navigator.php");
	include("./includes/date_functions.php");
	include_once ("./messages/".$language_code."/forum_messages.php");

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='forum'";
	$db->query($sql);
	while($db->next_record())
		$forum_settings[$db->f("setting_name")] = $db->f("setting_value");

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","forum.html");
	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("FORUM_TITLE", FORUM_TITLE);
	$t->set_var("MY_ACCOUNT_MSG",       MY_ACCOUNT_MSG);
	$t->set_var("MY_FORUM_TOPICS_MSG",  MY_FORUM_TOPICS_MSG);
	$t->set_var("ALL_FORUM_TOPICS_MSG", ALL_FORUM_TOPICS_MSG);
	$t->set_var("MY_FORUM_TOPICS_DESC", MY_FORUM_TOPICS_DESC);
	$t->set_var("NEW_TOPIC_MSG",        NEW_TOPIC_MSG);
	$t->set_var("NO_TOPICS_MSG",        NO_TOPICS_MSG);

	$user_topics = get_param("u");
	$forum_thread_url = new VA_URL("forum_thread.php", true);
	$forum_thread_url->add_parameter("thread_id", DB, "thread_id");
	$forum_new_thread_url = new VA_URL("forum_new_thread.php", true);
	$forum_url = new VA_URL("forum.php", true);

	$t->set_var("forum_new_thread_href", $forum_new_thread_url->get_url());
	$t->set_var("forum_href", $forum_url->get_url());
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("all_forum_href", "forum.php");
	$t->set_var("user_forum_href", "forum.php?u=1");

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "forum.php");
	$s->set_default_sorting(5, "desc");
	$s->set_sorter(TOPIC_NAME_COLUMN, "sorter_topic", "1", "topic");
	$s->set_sorter(TOPIC_AUTHOR_COLUMN, "sorter_user_name", "2", "user_name");
	$s->set_sorter(TOPIC_VIEWS_COLUMN, "sorter_views", "3", "views");
	$s->set_sorter(TOPIC_REPLIES_COLUMN, "sorter_replies", "4", "replies");
	$s->set_sorter(TOPIC_UPDATED_COLUMN, "sorter_date_modified", "5", "date_modified");

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "forum.php");

	include("./header.php");
	include("./footer.php");


	if($user_topics && strlen(get_session("session_user_id"))) {
		$where = " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	} else {
		$where = "";
	}

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "forum " . $where);
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query("SELECT * FROM " . $table_prefix . "forum " . $where . $s->order_by);
	if($db->next_record())
	{
		$t->set_var("no_records", "");
		$t->parse("sorters", false);
		do
		{
			$t->set_var("forum_thread_href", $forum_thread_url->get_url());
			$t->set_var("thread_id", $db->f("thread_id"));
			$t->set_var("topic", $db->f("topic"));
			$t->set_var("user_name", $db->f("user_name"));
			$t->set_var("views", intval($db->f("views")));
			$t->set_var("replies", intval($db->f("replies")));
			$date_modified = $db->f("date_modified", DATETIME);
			$t->set_var("date_modified", va_date($datetime_show_format, $date_modified));
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	if(isset($forum_settings["intro_text"]) && strlen(trim($forum_settings["intro_text"])))
	{
		$t->set_var("intro_text", $forum_settings["intro_text"]);
		$t->parse("intro_block", false);
	}

	if(strlen(get_session("session_user_id")))
	{
		if($user_topics) {
			$t->parse("all_topics_link", false);
		} else {
			$t->parse("user_topics_link", false);
		}
		$t->parse("user_links", false);
	}


	$t->set_var("admin_href", "admin.php");
	$t->pparse("main");

?>