<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  forum_thread.php                                         ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include("./includes/navigator.php");
	include("./includes/record.php");
	include("./includes/date_functions.php");
	include_once ("./messages/".$language_code."/forum_messages.php");

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","forum_thread.html");
	$t->set_var("site_url", $settings["site_url"]);

	$t->set_var("FORUM_TITLE",          FORUM_TITLE);
	$t->set_var("TOPIC_INFO_TITLE",     TOPIC_INFO_TITLE);
	$t->set_var("TOPIC_MESSAGE_TITLE",  TOPIC_MESSAGE_TITLE);

	$t->set_var("MY_ACCOUNT_MSG",       MY_ACCOUNT_MSG);
	$t->set_var("NEW_TOPIC_MSG",        NEW_TOPIC_MSG);
	$t->set_var("NO_TOPICS_MSG",        NO_TOPICS_MSG);
	$t->set_var("TOPIC_ADDED_MSG",      TOPIC_ADDED_MSG);
	$t->set_var("DATABASE_ERROR_MSG",   DATABASE_ERROR_MSG);
	$t->set_var("ADD_TOPIC_BUTTON",     ADD_TOPIC_BUTTON);
	                                                   
	$t->set_var("TOPIC_ADDED_BY_FIELD",  TOPIC_ADDED_BY_FIELD);
	$t->set_var("TOPIC_ADDED_DATE_FIELD",TOPIC_ADDED_DATE_FIELD);
	$t->set_var("TOPIC_UPDATED_FIELD",   TOPIC_UPDATED_FIELD);
	$t->set_var("TOPIC_NICKNAME_FIELD",  TOPIC_NICKNAME_FIELD);
	$t->set_var("TOPIC_EMAIL_FIELD",     TOPIC_EMAIL_FIELD);
	$t->set_var("TOPIC_NAME_FIELD",      TOPIC_NAME_FIELD);
	$t->set_var("TOPIC_MESSAGE_FIELD",   TOPIC_MESSAGE_FIELD);
	$t->set_var("TOPIC_NOTIFY_FIELD",    TOPIC_NOTIFY_FIELD);

	$t->set_var("TOPIC_MESSAGE_BUTTON",  TOPIC_MESSAGE_BUTTON);
	$t->set_var("CLEAR_BUTTON",          CLEAR_BUTTON);
	$t->set_var("RESET_BUTTON",          RESET_BUTTON);

	include("./header.php");
	include("./footer.php");

	$forum_url = new VA_URL("forum.php");
	$forum_url->add_parameter("u", REQUEST, "u");

	$forum_thread_url = new VA_URL("forum_thread.php");
	$forum_thread_url->add_parameter("u", REQUEST, "u");
	$forum_thread_url->add_parameter("thread_id", REQUEST, "thread_id");

	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("forum_href", $forum_url->get_url());
	$t->set_var("forum_thread_href", "forum_thread.php");
	$t->set_var("rnd", time());

	$thread_id = get_param("thread_id");
	$action = get_param("action");
	$rnd = get_param("rnd");

	$errors = "";

	if(!strlen($thread_id))
		$errors = TOPIC_MISS_ID_ERROR;

	$return_page = $forum_thread_url->get_url();

	$sql  = " SELECT user_id, user_name, user_email, remote_address, topic, ";
	$sql .= " description, email_notification, date_added, date_modified, views, replies ";
	$sql .= " FROM " . $table_prefix . "forum ";
	$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);

	$db->query($sql);
	if($db->next_record() && !strlen($errors))
	{
		$t->set_var("user_id", $db->f("user_id"));
		$thread_user_name = $db->f("user_name");
		$thread_user_email = $db->f("user_email");
		$thread_remote_address = $db->f("remote_address");
		$t->set_var("thread_user_name", $thread_user_name);
		$t->set_var("thread_user_email", $thread_user_email);
		$t->set_var("thread_remote_address", $thread_remote_address);

		$date_modified = $db->f("date_modified", DATETIME);
		$date_modified_string = va_date($datetime_show_format, $date_modified);
		$t->set_var("date_modified", $date_modified_string);
		$t->set_var("thread_modified", $date_modified_string);

		$date_added = $db->f("date_added", DATETIME);
		$date_added_string = va_date($datetime_show_format, $date_added);
		$t->set_var("thread_added", $date_added_string);

		$t->set_var("topic", htmlspecialchars($db->f("topic")));
		$description = htmlspecialchars($db->f("description"));
		$t->set_var("topic_description", nl2br($description));

		$email_notification = $db->f("email_notification");

		$views = intval($db->f("views"));
		$replies = intval($db->f("replies"));
		$t->set_var("views", $views);
		$t->set_var("replies", $replies);

		$last_message = $description;

		$sql  = " UPDATE " . $table_prefix . "forum SET views=" . $db->tosql(($views + 1), INTEGER);
		$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
		$db->query($sql);

	}
	else if(!strlen($errors))
	{
		$errors = TOPIC_WRONG_ID_ERROR;
	}

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("global_errors", false);
		$t->pparse("main", false);
		return;
	}


	$r = new VA_Record($table_prefix . "forum_messages");

	$r->add_textbox("thread_id", INTEGER);
	$r->add_hidden("u", INTEGER);
	//$r->add_textbox("admin_id", INTEGER);
	$r->add_textbox("user_name", TEXT, TOPIC_NICKNAME_FIELD);
	$r->change_property("user_name", REQUIRED, true);
	$r->add_textbox("user_email", TEXT, TOPIC_EMAIL_FIELD);
	$r->change_property("user_email", REQUIRED, true);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("message_text", TEXT, TOPIC_MESSAGE_FIELD);
	$r->change_property("message_text", REQUIRED, true);
	$r->add_textbox("date_added", DATETIME);

	$r->get_form_values();

	$session_rnd = get_session("session_rnd");
	$action = get_param("action");
	$rnd = get_param("rnd");

	if($action && $rnd != $session_rnd)
	{

		$r->validate();

		if(!strlen($r->errors))
		{
			$date_added = va_time();
			$remote_address = getenv("REMOTE_ADDR");
			$r->set_value("date_added", $date_added);
			$r->set_value("remote_address", $remote_address);

			//$r->set_value("admin_id", get_session("session_admin_id"));

			if($r->insert_record())
			{ 
				setcookie("cookie_forum_nick", $r->get_value("user_name"), time() + 3600 * 24 * 366);  
				setcookie("cookie_forum_email", $r->get_value("user_email"), time() + 3600 * 24 * 366);  

				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='forum'";
				$db->query($sql);
				while($db->next_record())
					$forum_settings[$db->f("setting_name")] = $db->f("setting_value");

				if($email_notification || (isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"]))
				{
					// prepare variables
					$date_added_string = va_date($datetime_show_format, $date_added);
			  
					// set variables for email
					$r->set_parameters();
					$t->set_var("date_added", $date_added_string);
					$t->set_var("message_added", $date_added_string);
					$t->set_var("date_modified", $date_added_string);
					$t->set_var("thread_modified", $date_added_string);

					$t->set_var("added_by", $r->get_value("user_name"));
					$t->set_var("nickname", $r->get_value("user_name"));
					$t->set_var("message_added_by", $r->get_value("user_name"));
					$t->set_var("message_user_name", $r->get_value("user_name"));
					$t->set_var("message_nickname", $r->get_value("user_name"));

					$t->set_var("user_email", $r->get_value("user_email"));
					$t->set_var("message_user_email", $r->get_value("user_email"));

					$t->set_var("message_remote_address", $r->get_value("remote_address"));
					$t->set_var("message_user_ip", $r->get_value("remote_address"));

					$t->set_var("message", $r->get_value("message_text"));

					$t->set_var("topic_description", $description);
					$t->set_var("description", $description);
					$t->set_var("topic_message", $description);

					// send notification to site administrator
					if(isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"])
					{			  
						$t->set_block("admin_subject", $forum_settings["admin_subject"]);
						$t->set_block("admin_message", $forum_settings["admin_message"]);
						$t->parse("admin_subject", false);
						$t->parse("admin_message", false);

						$mail_to = get_setting_value($forum_settings, "admin_email", $settings["admin_email"]);
						$mail_from = get_setting_value($forum_settings, "admin_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($forum_settings, "cc_emails");
						$mail_bcc = get_setting_value($forum_settings, "admin_mail_bcc");
						$mail_reply_to = get_setting_value($forum_settings, "admin_mail_reply_to");
						$mail_return_path = get_setting_value($forum_settings, "admin_mail_return_path");
						$mail_type = get_setting_value($forum_settings, "admin_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
						mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}
					// send notification to topic owner
					if($email_notification)
					{			  
						$t->set_block("user_subject", $forum_settings["user_subject"]);
						$t->set_block("user_message", $forum_settings["user_message"]);
						$t->parse("user_subject", false);
						$t->parse("user_message", false);

						$mail_from = get_setting_value($forum_settings, "user_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($forum_settings, "user_mail_cc");
						$mail_bcc = get_setting_value($forum_settings, "user_mail_bcc");
						$mail_reply_to = get_setting_value($forum_settings, "user_mail_reply_to");
						$mail_return_path = get_setting_value($forum_settings, "user_mail_return_path");
						$mail_type = get_setting_value($forum_settings, "user_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$user_message = str_replace("\r", "", $t->get_var("user_message"));
						mail($thread_user_email, $t->get_var("user_subject"), $user_message, $email_headers);
					}

				}

        // update forum thread info
				$sql  = " UPDATE " . $table_prefix . "forum SET replies=" . $db->tosql(($replies + 1), INTEGER);
				$sql .= " , date_modified=" . $db->tosql($date_added, DATETIME);
				$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
		else
		{
			//$errors .= "Please provide information in the sections with red, italicized headings, then click 'Submit'.<br>";	
			set_session("session_rnd", "");
		}
	} else if(strlen(get_session("session_user_id"))) { // new page (set default values)
		$r->set_value("user_name", get_session("session_user_name"));
		$r->set_value("user_email", get_session("session_user_email"));
	} else {
		$r->set_value("user_name", get_cookie("cookie_forum_nick"));
		$r->set_value("user_email", get_cookie("cookie_forum_email"));
	}

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "forum_thread.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "forum WHERE thread_id=" . $db->tosql($thread_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT message_id,admin_id,user_name,user_email,remote_address, ";
	$sql .= " message_text, date_added ";
	$sql .= " FROM " . $table_prefix . "forum_messages ";
	$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
	$sql .= " ORDER BY date_added DESC ";

	$db->query($sql);
	if($db->next_record())
	{
		$last_message = $db->f("message_text");
		do
		{
			$t->set_var("message_user_name", $db->f("user_name"));
			$t->set_var("message_user_email", $db->f("user_email"));
			$t->set_var("message_user_ip", $db->f("remote_address"));
			$t->set_var("message_id", $db->f("message_id"));

			if(strlen($db->f("admin_id")))
			{
				$t->parse("admin_block", false);
				$t->set_var("user_block", "");
			}
			else 
			{
				$t->parse("user_block", false);
				$t->set_var("admin_block", "");
			}

			$date_added = $db->f("date_added", DATETIME);
			$date_added_string = va_date($datetime_show_format, $date_added);
			$t->set_var("date_added", $date_added_string);

			$t->set_var("message_text", nl2br(htmlspecialchars($db->f("message_text"))));

			$t->parse("records", true);
		} while($db->next_record());

	}
	else
	{
		$t->set_var("records", "");
	}


	if(!strlen($action)) // (set default message text for reply)
	{
		$last_message = ">" . str_replace("\n", "\n>", $last_message);
		$r->set_value("message_text", $last_message);
	}

	$r->set_parameters();
	$t->set_var("page", $page_number);

	$t->parse("message_form", false);
	$t->parse("topic_info", false);

	if(strlen(get_session("session_user_id")))
	{
		$t->parse("user_links", false);
	}


	$t->pparse("main");

?>