<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  support_messages.php                                     ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/record.php");
	include_once ("./includes/date_functions.php");
	include_once ("./messages/".$language_code."/support_messages.php");

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","support_messages.html");
	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("SUPPORT_TITLE",            SUPPORT_TITLE);
	$t->set_var("SUPPORT_REQUEST_INF_TITLE",SUPPORT_REQUEST_INF_TITLE);
	$t->set_var("SUPPORT_REPLY_FORM_TITLE", SUPPORT_REPLY_FORM_TITLE);
	$t->set_var("MY_ACCOUNT_MSG",           MY_ACCOUNT_MSG);
	$t->set_var("DATABASE_ERROR_MSG",       DATABASE_ERROR_MSG);
	$t->set_var("MY_SUPPORT_ISSUES_MSG",    MY_SUPPORT_ISSUES_MSG);
	$t->set_var("SUPPORT_VIEW_MSG",         SUPPORT_VIEW_MSG);
	                                       
	$t->set_var("SUPPORT_USER_NAME_FIELD",  SUPPORT_USER_NAME_FIELD);
	$t->set_var("SUPPORT_ISER_EMAIL_FIELD", SUPPORT_ISER_EMAIL_FIELD);
	$t->set_var("SUPPORT_IDENTIFIER_FIELD", SUPPORT_IDENTIFIER_FIELD);
	$t->set_var("SUPPORT_ENVIRONMENT_FIELD",SUPPORT_ENVIRONMENT_FIELD);
	$t->set_var("SUPPORT_PRODUCT_FIELD",    SUPPORT_PRODUCT_FIELD);
	$t->set_var("SUPPORT_TYPE_FIELD",       SUPPORT_TYPE_FIELD);
	$t->set_var("SUPPORT_SUMMARY_FIELD",    SUPPORT_SUMMARY_FIELD);
	$t->set_var("SUPPORT_DESCRIPTION_FIELD",SUPPORT_DESCRIPTION_FIELD);
	$t->set_var("SUPPORT_DESCRIPTION_FIELD",SUPPORT_DESCRIPTION_FIELD);
	$t->set_var("SUPPORT_CURRENT_STATUS_FIELD",SUPPORT_CURRENT_STATUS_FIELD);
	$t->set_var("SUPPORT_STATUS_FIELD",     SUPPORT_STATUS_FIELD);
	$t->set_var("SUPPORT_MESSAGE_FIELD",    SUPPORT_MESSAGE_FIELD);
	$t->set_var("SUPPORT_ADDED_FIELD",      SUPPORT_ADDED_FIELD);
	$t->set_var("SUPPORT_ADDED_BY_FIELD",   SUPPORT_ADDED_BY_FIELD);

	$t->set_var("SUPPORT_UPDATED_FIELD",    SUPPORT_UPDATED_FIELD);

	$t->set_var("SUPPORT_REPLY_BUTTON",     SUPPORT_REPLY_BUTTON);
	$t->set_var("CLEAR_BUTTON",             CLEAR_BUTTON);
	$t->set_var("RESET_BUTTON",             RESET_BUTTON);

	include("./header.php");
	include("./footer.php");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("user_support_href", "user_support.php");
	$t->set_var("support_messages_href", "support_messages.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("rnd", time());

	$support_id = get_param("support_id");
	$vc = get_param("vc");
	$action = get_param("action");
	$rnd = get_param("rnd");

	$errors = "";

	if(!strlen($support_id))
		$errors = SUPPORT_MISS_ID_ERROR;
	else if(!strlen($vc))
		$errors = SUPPORT_MISS_CODE_ERROR;

	$return_page = "support_messages.php?support_id=" . $support_id . "&vc=" . $vc;

	$sql  = " SELECT s.user_id, s.user_name, s.user_email, s.remote_address, s.identifier, ";
	$sql .= " s.environment, p.product_name, st.type_name, s.summary, s.description,   ";
	$sql .= " ss.status_name, sp.priority_name, s.date_added, s.date_modified, ";
	$sql .= " aa.admin_name as assign_to ";
	$sql .= " FROM (((((" . $table_prefix . "support s ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_products p ON p.product_id=s.support_product_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=s.support_status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id=s.support_type_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_priorities sp ON sp.priority_id=s.support_priority_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "admins aa ON aa.admin_id=s.admin_id_assign_to) ";
	$sql .= " WHERE s.support_id=" . $db->tosql($support_id, INTEGER);

	$db->query($sql);
	if($db->next_record() && !strlen($errors))
	{
		$t->set_var("user_id", $db->f("user_id"));
		$user_name = $db->f("user_name");
		$t->set_var("user_name", $user_name);
		$user_email = $db->f("user_email");
		$t->set_var("user_email", $db->f("user_email"));
		$t->set_var("identifier", htmlspecialchars($db->f("identifier")));
		$t->set_var("environment", htmlspecialchars($db->f("environment")));
		$t->set_var("remote_address", $db->f("remote_address"));
		$t->set_var("product_name", $db->f("product_name"));
		$t->set_var("product", $db->f("product_name"));
		$t->set_var("assign_to", $db->f("assign_to"));

		$t->set_var("type", $db->f("type_name"));
		$current_status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
		$t->set_var("current_status", $current_status);
		$priority = strlen($db->f("priority_name")) ? $db->f("priority_name") : "Normal";
		$t->set_var("priority", $priority);
		$date_modified = $db->f("date_modified", DATETIME);
		$date_modified_string = va_date($datetime_show_format, $date_modified);
		$t->set_var("date_modified", $date_modified_string);

		$date_added = $db->f("date_added", DATETIME);
		$date_added_string = va_date($datetime_show_format, $date_added);
		$t->set_var("request_added", $date_added_string);
		$t->set_var("summary", htmlspecialchars($db->f("summary")));
		$description = $db->f("description");
		$t->set_var("request_description", nl2br(htmlspecialchars($description)));

		$last_message = $description;

		$sql  = " UPDATE " . $table_prefix . "support_messages SET date_viewed=" . $db->tosql(va_time(), DATETIME);
		$sql .= " WHERE support_id=" . $db->tosql($support_id, INTEGER);
		$sql .= " AND internal=0 AND admin_id_assign_by IS NOT NULL AND date_viewed IS NULL";
		$db->query($sql);

		//$vc = md5($support_id . $date_added[3].$date_added[4].$date_added[5]);
	}	else if(!strlen($errors)) {
		$errors = SUPPORT_WRONG_ID_ERROR;
	}

	if(!strlen($errors) && $vc != md5($support_id . $date_added[3].$date_added[4].$date_added[5]))
		$errors = SUPPORT_WRONG_CODE_ERROR;

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("global_errors", false);
		$t->pparse("main", false);
		return;
	}


	$r = new VA_Record($table_prefix . "support_messages");

	$support_statuses = get_db_values("SELECT * FROM " . $table_prefix . "support_statuses WHERE show_for_user=1 ", array(array("", SUPPORT_SELECT_STATUS_MSG)));

	$r->add_textbox("support_id", INTEGER);
	$r->add_textbox("internal", INTEGER);
	$r->add_select("support_status_id", INTEGER, $support_statuses, SUPPORT_STATUS_FIELD);
	$r->change_property("support_status_id", PARSE_NAME, "response_status");
	$r->change_property("support_status_id", REQUIRED, true);
	//$r->add_textbox("admin_id_assign_by", INTEGER);
	$r->add_textbox("message_text", TEXT, SUPPORT_MESSAGE_FIELD);
	$r->change_property("message_text", PARSE_NAME, "response_message");
	$r->change_property("message_text", REQUIRED, true);
	$r->add_textbox("date_added", DATETIME);

	$r->get_form_values();

	$session_rnd = get_session("session_rnd");
	$action = get_param("action");
	$rnd = get_param("rnd");

	if($action && $rnd != $session_rnd)
	{
		$r->validate();

		if(!strlen($r->errors))
		{
			$date_added = va_time();
			$r->set_value("internal", 0);
			$r->set_value("date_added", $date_added);
			//$r->set_value("admin_id_assign_by", get_session("session_admin_id"));

			if($r->insert_record())
			{ 
				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='support'";
				$db->query($sql);
				while($db->next_record())
					$support_settings[$db->f("setting_name")] = $db->f("setting_value");

				// send email notification to admin
				if($support_settings["admin_notification"])
				{
					$t->set_block("admin_subject", $support_settings["admin_subject"]);
					$t->set_block("admin_message", $support_settings["admin_message"]);

					$date_added_string = va_date($datetime_show_format, $date_added);
					$support_url = $settings["site_url"] . "support_messages.php?support_id=" . $support_id . "&vc=" . $vc;
			  
					$r->set_parameters();
					$t->set_var("vc", $vc);
					$t->set_var("support_url", $support_url);
					$t->set_var("status", get_array_value($r->get_value("support_status_id"), $support_statuses));
					$t->set_var("message_added", $date_added_string);
					$t->set_var("date_added", $date_added_string);
					$t->set_var("date_modified", $date_added_string);
					$t->set_var("description", $description);
					$t->set_var("message_text", $r->get_value("message_text"));
			  
					$mail_to = get_setting_value($support_settings, "admin_email", $settings["admin_email"]);
					$mail_from = get_setting_value($support_settings, "admin_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($support_settings, "cc_emails");
					$mail_bcc = get_setting_value($support_settings, "admin_mail_bcc");
					$mail_reply_to = get_setting_value($support_settings, "admin_mail_reply_to");
					$mail_return_path = get_setting_value($support_settings, "admin_mail_return_path");
					$mail_type = get_setting_value($support_settings, "admin_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					$t->parse("admin_subject", false);
					$t->parse("admin_message", false);

					$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
					mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
				}

        // update support request info
				$sql  = " UPDATE " . $table_prefix . "support SET support_status_id=" . $db->tosql($r->get_value("support_status_id"), INTEGER);
				$sql .= " , date_modified=" . $db->tosql(va_time(), DATETIME);
				$sql .= " WHERE support_id=" . $db->tosql($support_id, INTEGER);
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
		else
		{
			//$errors .= "Please provide information in the sections with red, italicized headings, then click 'Submit'.<br>";	
			set_session("session_rnd", "");
		}
	}
	else // new page (set default values)
	{
		//$r->set_value("is_showing", "1");
	}


	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "support_messages.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "support_messages WHERE support_id=" . $db->tosql($support_id, INTEGER) . " AND internal=0 ");
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT sm.admin_id_assign_by,a.admin_name,ss.status_name, ";
	$sql .= " sm.message_text, sm.date_added, sm.date_viewed ";
	$sql .= " FROM ((" . $table_prefix . "support_messages sm ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=sm.support_status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "admins a ON a.admin_id=sm.admin_id_assign_by) ";
	$sql .= " WHERE sm.support_id=" . $db->tosql($support_id, INTEGER);
	$sql .= " AND internal=0 ";
	$sql .= " ORDER BY sm.date_added DESC ";

	$db->query($sql);
	if($db->next_record())
	{
		$last_message = $db->f("message_text");

		do
		{
			$status = strlen($db->f("status_name")) ? $db->f("status_name") : SUPPORT_STATUS_NEW_MSG;
			$t->set_var("status", $status);

			if(strlen($db->f("admin_id_assign_by")))
			{
				$posted_by = $db->f("admin_name");
				$viewed_by = SUPPORT_VIEWED_BY_USER_MSG;
			}
			else 
			{
				$posted_by = strlen($user_name) ? $user_name . " &lt;" . $user_email . "&gt;" : $user_email;
				$viewed_by = SUPPORT_VIEWED_BY_ADMIN_MSG;
			}
			$t->set_var("posted_by", $posted_by);
			$t->set_var("viewed_by", $viewed_by);

			$date_added = $db->f("date_added", DATETIME);
			$date_added_string = va_date($datetime_show_format, $date_added);
			$t->set_var("date_added", $date_added_string);

			$date_viewed = $db->f("date_viewed", DATETIME);
			if(is_array($date_viewed)) {
				$date_viewed_string = va_date($datetime_show_format, $date_viewed);
				$t->set_var("date_viewed", "<font color=\"blue\">" . $date_viewed_string . "</font>");
			} else {
				$t->set_var("date_viewed", "<font color=\"red\">" . SUPPORT_NOT_VIEWED_MSG . "</font>");
			}

			$t->set_var("message_text", nl2br(htmlspecialchars($db->f("message_text"))));

			$t->parse("records", true);
		} while($db->next_record());

	}
	else
	{
		$t->set_var("records", "");
	}

	if(strlen(get_session("session_user_id"))) {
		$t->parse("user_links", false);
	}

	if(!strlen($action)) // (set default message text for reply)
	{
		$last_message = ">" . str_replace("\n", "\n>", $last_message);
		$r->set_value("message_text", $last_message);
	}

	$r->set_parameters();
	$t->set_var("page", $page_number);
	$t->set_var("vc", $vc);
	$t->parse("reply_form", false);
	$t->parse("request_info", false);

	$t->pparse("main");

?>