<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  user_orders.php                                          ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	$includes_path = "./includes/";
	include_once ($includes_path . "/common.php");
	include_once ($includes_path . "/sorter.php");
	include_once ($includes_path . "/navigator.php");
	include_once ($includes_path . "/date_functions.php");
	include_once ($includes_path . "/record.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	check_user_session();

	$currency_left = ""; $currency_right = "";
	if($settings["currency_position"] == 1)
		$currency_left = $settings["currency_sign"];
	else if($settings["currency_position"] == 2)
		$currency_right = $settings["currency_sign"];

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","user_orders.html");
	$t->set_var("user_orders_href", "user_orders.php");
	$t->set_var("user_order_href", "user_order.php");
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("MY_ORDERS_MSG", MY_ORDERS_MSG);
	$t->set_var("MY_ACCOUNT_MSG", MY_ACCOUNT_MSG);
	$t->set_var("VIEW_ORDER_DETAILS_MSG", VIEW_ORDER_DETAILS_MSG);
	$t->set_var("NO_ORDERS_MSG", NO_ORDERS_MSG);

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "user_orders.php");
	$s->set_default_sorting(1, "desc");
	$s->set_sorter(ORDER_NUMBER_COLUMN, "sorter_id", "1", "order_id");
	$s->set_sorter(ORDER_STATUS_COLUMN, "sorter_date", "2", "order_placed_date");
	$s->set_sorter(ORDER_ADDED_COLUMN, "sorter_status", "3", "order_status");
	$s->set_sorter(ORDER_TOTAL_COLUMN, "sorter_total", "4", "goods_total");

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "user_orders.php");

	include("./header.php");
	include("./footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "orders o WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT o.order_id, o.order_placed_date, os.status_name, o.goods_total ";
	$sql .= " FROM " . $table_prefix . "orders o, " . $table_prefix . "order_statuses os ";
	$sql .= " WHERE o.order_status=os.status_id ";
	$sql .= " AND o.user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	$db->query($sql . $s->order_by);
	if($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do
		{
			$t->set_var("order_id", $db->f("order_id"));

			$placed_date = $db->f("order_placed_date", DATETIME);
			$t->set_var("order_placed_date", va_date($datetime_show_format, $placed_date));

			$t->set_var("order_status", $db->f("status_name"));
			$t->set_var("goods_total", $currency_left . number_format($db->f("goods_total"), 2) . $currency_right);
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>