<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_pages.php                                          ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");

	check_admin_security("web_pages");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_pages.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_page_href", "admin_page.php");

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_pages.php");
	$s->set_sorter("ID", "sorter_page_id", "1", "page_id");
	$s->set_sorter("Page Name", "sorter_page_title", "2", "page_title");
	$s->set_sorter("Page Code", "sorter_page_code", "3", "page_code");
	$s->set_sorter("Show on Site", "sorter_is_showing", "4", "is_showing");

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_pages.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "pages");
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query("SELECT page_id,page_code,page_title,is_showing FROM " . $table_prefix . "pages " . $s->order_by);
	if($db->next_record())
	{
		$t->set_var("no_records", "");
		do
		{
			$t->set_var("page_id", $db->f("page_id"));
			$t->set_var("page_title", $db->f("page_title"));
			$t->set_var("page_code", $db->f("page_code"));
			$is_showing = $db->f("is_showing") ? "Yes" : "No";
			$t->set_var("is_showing", $is_showing);
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>