<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_support_predefined_edit.php                        ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("support");
	$is_popup = get_param("is_popup");


  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_support_predefined_edit.html");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_support_type_href", "admin_support_predefined_edit.php");
	$t->set_var("admin_support_types_href", "admin_support_predefined.php");

	$r = new VA_Record($table_prefix . "support_predefined");
	$r->return_page = "admin_support_predefined.php";

	$r->add_where("reply_id", INTEGER);
	$r->add_textbox("subject", TEXT, "Subject");
	$r->parameters["subject"][REQUIRED] = true;
//	$r->change_property("subject", REQUIRED, true);
	$r->add_textbox("body", TEXT, "Body");
	$reply_types = get_db_values("SELECT DISTINCT reply_type, reply_type FROM ".$table_prefix."support_predefined", array(array("", "Select Reply Type")));
	$r->add_select("reply_type", TEXT, $reply_types, "Type");
	$r->parameters["reply_type"][REQUIRED] = true;
//	$r->change_property("reply_type", REQUIRED, true);

	$r->get_form_values();

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->pparse("main");

?>
