<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  basket.php                                               ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

	include_once ("./includes/common.php");
	include_once ("./includes/shopping_cart.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	// load html template
  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","basket.html");

	$t->set_var("basket_href", "basket.php");
	$t->set_var("checkout_href", "checkout.php");
	$t->set_var("products_href", "products.php");
	$t->set_var("CART_TITLE",          CART_TITLE);     
	$t->set_var("EMPTY_CART_MSG",      EMPTY_CART_MSG);     
	$t->set_var("PROD_TITLE_COLUMN",   PROD_TITLE_COLUMN);     
	$t->set_var("PROD_QTY_COLUMN",     PROD_QTY_COLUMN);         
	$t->set_var("PROD_PRICE_COLUMN",   PROD_PRICE_COLUMN);       
	$t->set_var("PROD_TOTAL_COLUMN",   PROD_TOTAL_COLUMN);  
	$t->set_var("GOODS_TOTAL_MSG",     GOODS_TOTAL_MSG); 
	$t->set_var("CART_TOTAL_MSG",      CART_TOTAL_MSG);     
	$t->set_var("CONTINUE_SHOPPING_MSG",CONTINUE_SHOPPING_MSG);  
	$t->set_var("REMOVE_FROM_CART_MSG",REMOVE_FROM_CART_MSG);
	$t->set_var("CLEAR_CART_MSG",      CLEAR_CART_MSG);
	$t->set_var("ADD_TO_CART_MSG",     ADD_TO_CART_MSG);    
	$t->set_var("VIEW_CART_MSG",       VIEW_CART_MSG);      
	$t->set_var("AMEND_CART_MSG",      AMEND_CART_MSG);     
	$t->set_var("GOTO_CHECKOUT_MSG",   GOTO_CHECKOUT_MSG);

	$t->set_var("REMOVE_FROM_CART_JS", REMOVE_FROM_CART_JS);    
	$t->set_var("CLEAR_CART_JS",       CLEAR_CART_JS);      
	$t->set_var("CART_QTY_ZERO_JS",    CART_QTY_ZERO_JS);     
	$t->set_var("ALTER_CART_QTY_JS",   ALTER_CART_QTY_JS);

	// generate page link with query parameters
	$page = "basket.php";
	$remove_parameters = array("rnd", "cart", "item_id", "type", "cart_id", "quantity", "new_quantity");
	$query_string = get_query_string($HTTP_GET_VARS, $remove_parameters, "", true);
	$page	.= $query_string;
	$page_link  = $page;
	$page_link .= strlen($query_string) ? "&" : "?";

	srand ((double) microtime() * 1000000);
	$random_value = rand();

	$remove_link = $page_link . "cart=RM&rnd=" . $random_value . "&cart_id=";
	$remove_all_link = $page_link . "cart=CLR&rnd=" . $random_value;


	$t->set_var("random_value", $random_value);
	$t->set_var("quantity_control", $settings["quantity_control"]);

	// set up return page
	$rp_link = get_param("rp");
	if(!$rp_link) $rp_link = "products.php";
	$t->set_var("rp_href", $rp_link);

	include("./header.php");
	include("./footer.php");

	$shopping_cart = get_session("shopping_cart");
	if(is_array($shopping_cart))
	{
		$t->set_var("empty", "");
		$currency_left = ""; $currency_right = "";
		if($settings["currency_position"] == 1)
			$currency_left = $settings["currency_sign"];
		else if($settings["currency_position"] == 2)
			$currency_right = $settings["currency_sign"];

		$goods_total = 0;
		$total_quantity = 0;

		reset($shopping_cart);
		while(list($cart_id, $item) = each($shopping_cart))
		{
			$item_id = $item["ITEM_ID"];
			$properties = $item["PROPERTIES"];
			$quantity = $item["QUANTITY"];

			$sql  = " SELECT item_name, item_type_id, stock_level, small_image, price, ";
			$sql .= " is_sales, sales_price, stock_level, use_stock_level, hide_out_of_stock ";
			$sql .= " FROM " . $table_prefix . "items ";
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);

			$db->query($sql);
			if($db->next_record())
			{
				// some price calculation
				$price = calculate_price($db->f("price"), $db->f("is_sales"), $db->f("sales_price"));

				$item_name = $db->f("item_name");
				$stock_level = $db->f("stock_level");
				$use_stock_level = $db->f("use_stock_level");
				$hide_out_of_stock = $db->f("hide_out_of_stock");

				// set item variables into html
				$t->set_var("item_name", $db->f("item_name"));
				if($settings["change_quantity"])
				{
					if(strtoupper($settings["quantity_control"]) == "LISTBOX")
					{
						$max_quantity = $quantity + 10;
						if($hide_out_of_stock && $max_quantity > $stock_level && $use_stock_level)
							$max_quantity = $stock_level;
						// load data for listbox
						$quantities = array();
						for($i = 0; $i <= $max_quantity; $i++)
							$quantities[] = array($i, $i);
						$quantity_select = "<select name=\"quantity\""; 
						$quantity_select .= " onChange=\"return changeListbox(";
						$quantity_select .= "'" . $cart_id . "', this, ";
						$quantity_select .= "'" . str_replace("'", "\\'", $item_name) . "', '" . $quantity . "')\">";
						$quantity_select .= get_options($quantities, $quantity);
						$quantity_select .= "</select>"; 
						$t->set_var("quantity", $quantity_select);				
					}
					else if(strtoupper($settings["quantity_control"]) == "TEXTBOX")
					{
						$quantity_textbox = "<input type=\"text\" name=\"quantity\"";
						$quantity_textbox .= " value=\"" . $quantity . "\" size=\"4\" maxlength=\"6\"";
						$quantity_textbox .= " onChange=\"return changeTextbox(";
						$quantity_textbox .= "'" . $cart_id . "', this, ";
						$quantity_textbox .= "'" . str_replace("'", "\\'", $item_name) . "', '" . $quantity . "')\">";
						//.options[this.selectedIndex].text, '{title}', {qty})">

						$t->set_var("quantity", $quantity_textbox);				
					}
					else
						$t->set_var("quantity", $quantity);				
				}
				else
					$t->set_var("quantity", $quantity);				

				$t->set_var("small_image", $db->f("small_image"));				
				$t->set_var("remove_href", $remove_link . $cart_id);

				// show properties if their available
				$properties_values = "";
				$additional_price = 0;
				if(is_array($properties))
				{
					reset($properties);
					while(list($property_id, $property_values) = each($properties))
					{
						$sql  = " SELECT property_name, control_type ";
						$sql .= " FROM " . $table_prefix . "items_properties ";
						$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
						$db->query($sql);
						if($db->next_record()) {
							$property_name = $db->f("property_name");
							$control_type = $db->f("control_type");
							if(strtoupper($control_type) == "LISTBOX" || strtoupper($control_type) == "RADIOBUTTON" 
								|| strtoupper($control_type) == "CHECKBOXLIST") {
								$values_list = "";
								for($pv = 0; $pv < sizeof($property_values); $pv++) {
									$sql  = " SELECT property_value, additional_price ";
									$sql .= " FROM " . $table_prefix . "items_properties_values ipv ";
									$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
									$sql .= " AND item_property_id=" . $db->tosql($property_values[$pv], INTEGER);
									$db->query($sql);
									if($db->next_record()) {
										$additional_price += $db->f("additional_price");
										if ($values_list) { $values_list .= ", "; } 
										$values_list .= $db->f("property_value");
									}
								}
								$properties_values .= "<br>" . $property_name . ": " . $values_list;
							} else if ($property_values[0]) {
								$properties_values .= "<br>" . $property_name . ": " . $property_values[0];
							}
						}
					}
				}
				$t->set_var("properties_values", $properties_values);

				$price = round($price + $additional_price, 2);
				$item_total = $price * $quantity;
				$goods_total += $item_total;
				$total_quantity += $quantity;
				$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
				$t->set_var("item_total", $currency_left . number_format($item_total, 2) . $currency_right);

				$t->parse("items", true);
			}
			else
			{
				unset($shopping_cart[$cart_id]);
			}
		}

		$t->set_var("total_quantity", $total_quantity);
		$t->set_var("goods_total", $currency_left . number_format($goods_total, 2) . $currency_right);
		$t->set_var("remove_all_href", $remove_all_link);

		$t->parse("basket", false);
		$t->parse("basket_links", false);
	}
	else
	{
		$t->set_var("basket", "");
		$t->parse("empty", false);
	}

	
	$t->pparse("main");

?>
