<?
function offers($block_name)
{
	global $t;
	global $db, $table_prefix;
	global $settings;
	global $page_settings;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_offers.html");
	$t->set_var("product_details_href", "product_details.php");
	$t->set_var("SPECIAL_OFFER_TITLE", SPECIAL_OFFER_TITLE);
	$t->set_var("MORE_MSG",            MORE_MSG);
	$t->set_var("READ_MORE_MSG",       READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",      CLICK_HERE_MSG);

	// set up variables for navigator
	$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "items i ";
	$sql .= " WHERE i.is_special_offer=1 AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$db->query($sql);
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = get_setting_value($page_settings, "products_per_page", 10);
	$pages_number = 5;
	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "index.php");
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);


	$sql  = " SELECT i.item_id,i.item_name,i.short_description, ";
	$sql .= " i.small_image, i.special_offer ";
	$sql .= " FROM " . $table_prefix . "items i ";
	$sql .= " WHERE i.is_special_offer=1 AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " ORDER BY item_order ";

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql);
	if($db->next_record())
	{
		$so_columns = get_setting_value($page_settings, "products_columns", 1);
		$t->set_var("image_column", (20 / $so_columns) . "%");
		$t->set_var("offer_column", (80 / $so_columns) . "%");
		$so_number = 0;
		do
		{
			$so_number++;
			$item_id = $db->f("item_id");
			$item_name = $db->f("item_name");
		
			$t->set_var("item_id", $item_id);
			$t->set_var("item_name", $item_name);
			$t->set_var("special_offer", nl2br($db->f("special_offer")));

			$small_image = $db->f("small_image");
			if($small_image)
			{
        $image_size = preg_match("/^http\:\/\//", $small_image) ? "" : @GetImageSize($small_image);
        $t->set_var("alt", htmlspecialchars($item_name));
        $t->set_var("src", htmlspecialchars($small_image));
				if(is_array($image_size))
				{
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				}
				else
				{
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->parse("small_image", false);
			}
			else
			{
				$t->set_var("small_image", "");
			}

			$t->parse("items_cols");
			if($so_number % $so_columns == 0)
			{
				$t->parse("items_rows");
				$t->set_var("items_cols", "");
			}
			
		} while ($db->next_record());              	

		if($so_number % $so_columns != 0)
			$t->parse("items_rows");

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>