<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  index.php                                                ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include("./includes/navigator.php");
	include("./includes/tree.php");
	include("./includes/date_functions.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	// include blocks
	include_once ("./block_categories_list.php");
	include_once ("./block_top_products.php");
	include_once ("./block_events.php");
	include_once ("./block_news.php");
	include_once ("./block_offers.php");
	include_once ("./block_custom.php");
	include_once ("./block_cart.php");

	$page_settings = get_page_settings("index");
	$script_name = "index.php";

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","index.html");
  $t->set_var("HOME_PAGE_TITLE", HOME_PAGE_TITLE);

	$t->set_var("products_href", "products.php");
	$t->set_var("event_href", "event.php");
	$t->set_var("current_href", urlencode("index.php"));

	include_once ("./header.php");

	$greeting_html = $settings["html_on_index"];
	if(strlen($greeting_html))
	{
		$t->set_var("greeting_html", $greeting_html);
		$t->parse("greeting_block", false);
	}
	else
	{
		$t->set_var("greeting_block", "");
	}

	if(is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if ($setting_name == "top_products_block") {
				top_products($setting_value);
			} else if ($setting_name == "search_block") {
				search_form($setting_value);
			} else if ($setting_name == "login_block") {
				login_form($setting_value);
			} else if ($setting_name == "cart_block") {
				small_cart($setting_value);
			} else if ($setting_name == "categories_block") {
				categories($setting_value);
			} else if ($setting_name == "offers_block") {
				offers($setting_value);
			} else if ($setting_name == "events_block") {
				events($setting_value);
			} else if ($setting_name == "news_block") {
				news($setting_value);
			} else if (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} 
		}
	}

	if(!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if(!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if(!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}


	include_once ("./footer.php");

	$t->pparse("main");
?>