<?php
	// date messages
	define("YEAR_MSG",   "Year");
	define("MONTH_MSG",  "Month");
	define("DAY_MSG",    "Day");
	define("HOUR_MSG",   "Hour");
	define("MINUTE_MSG", "Minute");
	define("SECOND_MSG", "Second");

	// months
	define("JANUARY",   "January");
	define("FEBRUARY",  "February");
	define("MARCH",     "March");
	define("APRIL",     "April");
	define("MAY",       "May");
	define("JUNE",      "June");
	define("JULY",      "July");
	define("AUGUST",    "August");
	define("SEPTEMBER", "September");
	define("OCTOBER",   "October");
	define("NOVEMBER",  "November");
	define("DECEMBER",  "December");

	define("JANUARY_SHORT",   "Jan");
	define("FEBRUARY_SHORT",  "Feb");
	define("MARCH_SHORT",     "Mar");
	define("APRIL_SHORT",     "Apr");
	define("MAY_SHORT",       "May");
	define("JUNE_SHORT",      "Jun");
	define("JULY_SHORT",      "Jul");
	define("AUGUST_SHORT",    "Aug");
	define("SEPTEMBER_SHORT", "Sep");
	define("OCTOBER_SHORT",   "Oct");
	define("NOVEMBER_SHORT",  "Nov");
	define("DECEMBER_SHORT",  "Dec");

	// weekdays
	define("SUNDAY",    "Sunday");
	define("MONDAY",    "Monday");
	define("TUESDAY",   "Tuesday");
	define("WEDNESDAY", "Wednesday");
	define("THURSDAY",  "Thursday");
	define("FRIDAY",    "Friday");
	define("SATURDAY",  "Saturday");

	define("SUNDAY_SHORT",    "Sun");
	define("MONDAY_SHORT",    "Mon");
	define("TUESDAY_SHORT",   "Tue");
	define("WEDNESDAY_SHORT", "Wed");
	define("THURSDAY_SHORT",  "Thu");
	define("FRIDAY_SHORT",    "Fri");
	define("SATURDAY_SHORT",  "Sat");

	// validation messages
	define("REQUIRED_MESSAGE",   "<b>{field_name}</b> is required.");
	define("UNIQUE_MESSAGE",     "The value in field <b>{field_name}</b> is already in database.");
	define("VALIDATION_MESSAGE", "Validation failed for field {field_name}.");
	define("MATCHED_MESSAGE",    "<b>{field_one}</b> and <b>{field_two}</b> didn't match.");

	define("INCORRECT_DATE_MESSAGE",  "<b>{field_name}</b> has incorrect date value. Use calendar dates.");
	define("INCORRECT_MASK_MESSAGE",  "<b>{field_name}</b> didn't match with mask. Use following '<b>{field_mask}</b>'");
	define("INCORRECT_EMAIL_MESSAGE", "Invalid email format in field {field_name}.");
	define("INCORRECT_VALUE_MESSAGE", "Incorrect value in field <b>{field_name}</b>.");

	define("MIN_VALUE_MESSAGE",  "The value in field <b>{field_name}</b> can't be less than {min_value}.");
	define("MAX_VALUE_MESSAGE",  "The value in field <b>{field_name}</b> can't be greater than {max_value}.");
	define("MIN_LENGTH_MESSAGE", "The length in field <b>{field_name}</b> can't be less than {min_length} symbols.");
	define("MAX_LENGTH_MESSAGE", "The length in field <b>{field_name}</b> can't be greater than {max_length} symbols.");

	define("FILE_PERMISSION_MESSAGE",   "Don't have writable permission to file <b>'{file_name}'</b>. Please change file permission before continue.");
	define("FOLDER_PERMISSION_MESSAGE", "Don't have writable permission to folder <b>'{folder_name}'</b>. Please change folder permission before continue.");
	define("DATABASE_ERROR_MSG",        "Database errors has occurred.");
	define("ERRORS_MSG",                "Errors");

	// titles 
	define("TOP_RATED_TITLE",       "Top Rated");
	define("SEARCH_TITLE",          "Search");
	define("LOGIN_TITLE",           "User Login");
	define("CATEGORIES_TITLE",      "Categories");
	define("SPECIAL_OFFER_TITLE",   "Special Offer");
	define("NEWS_TITLE",            "News");
	define("EVENTS_TITLE",          "Events");
	define("PROFILE_TITLE",         "Profile");
	define("USER_HOME_TITLE",       "Home Page");
	define("DOWNLOAD_TITLE",        "Download");
	define("FAQ_TITLE",             "Frequently Asked Questions");
	define("HOME_PAGE_TITLE",       "Home Page");

	// main terms
	define("NO_MSG",               "No");
	define("YES_MSG",              "Yes");
	define("NOT_AVAILABLE_MSG",    "N/A");
	define("MORE_MSG",             "more...");
	define("READ_MORE_MSG",        "read more...");
	define("CLICK_HERE_MSG",       "click here");
	define("ENTER_YOUR_MSG",       "Enter your");
	define("CHOOSE_A_MSG",         "Choose a");
	define("PLEASE_CHOOSE_MSG",    "Please choose");
	define("SELECT_MSG",           "Select");
	define("NEXT_PAGE_MSG",        "Next");
	define("PREV_PAGE_MSG",        "Previous");
	define("FIRST_PAGE_MSG",       "First");
	define("LAST_PAGE_MSG",        "Last");
	define("OF_PAGE_MSG",          "of");
	define("TOP_CATEGORY_MSG",     "Top");
	define("CLOSE_WINDOW_MSG",     "Close Window");
	define("ASTERISK_MSG",         "asterisk (*) - required fields");
	define("PROVIDE_INFO_MSG",     "Please provide information in the sections with red then click '{button_name}'.");

	// account messages
	define("LOGIN_AS_MSG",         "You login as");
	define("LOGIN_INFO_MSG",       "Login Information");
	define("ACCESS_HOME_MSG",      "To access your home");
	define("REMEMBER_LOGIN_MSG",   "Remember my login and password");
	define("ENTER_LOGIN_MSG",      "Enter your login and password to continue");
	define("LOGIN_PASSWORD_ERROR", "Password or Login is incorrect.");
	define("CHANGE_DETAILS_MSG",   "Change your details");
	define("CHANGE_DETAILS_DESC",  "Click link above if you like to change contact or login information you entered during opening account procedure.");
	define("CHANGE_PASSWORD_MSG",  "Change password");
	define("CHANGE_PASSWORD_DESC", "The link below will take you to the page were you can change your password.");
	define("SIGN_UP_MSG",          "Sign up now");
	define("MY_ACCOUNT_MSG",       "My Account");
	define("NEW_USER_MSG",         "New User");
	define("EXISTS_USER_MSG",      "Existing users");
	define("EDIT_PROFILE_MSG",     "Edit Profile");
	define("PERSONAL_DETAILS_MSG", "Personal Details");
	define("DELIVERY_DETAILS_MSG", "Delivery Details");
	define("SAME_DETAILS_MSG",     "If the delivery details is the same as above tick here<br> if not then please complete the details below");
	define("DELIVERY_MSG",         "Delivery");

	// buttons
	define("GO_BUTTON",          "Go");
	define("CONTINUE_BUTTON",    "Continue");
	define("BACK_BUTTON",        "Back");
	define("NEXT_BUTTON",        "Next");
	define("PREV_BUTTON",        "Previous");
	define("SIGN_IN_BUTTON",     "Sign in");
	define("LOGOUT_BUTTON",      "Logout");
	define("SEARCH_BUTTON",      "Search");
	define("RATE_IT_BUTTON",     "Rate it!");
	define("UPDATE_BUTTON",      "Update");
	define("REGISTER_BUTTON",    "Register");
	define("CANCEL_BUTTON",      "Cancel");
	define("CLEAR_BUTTON",       "Clear");
	define("RESET_BUTTON",       "Reset");

	// fields
	define("LOGIN_FIELD",        "Username");
	define("PASSWORD_FIELD",     "Password");
	define("CONFIRM_PASS_FIELD", "Confirm Password");
	define("NEW_PASS_FIELD",     "New Password");
	define("CURRENT_PASS_FIELD", "Current Password");
	define("NAME_FIELD",         "Name");
	define("FIRST_NAME_FIELD",   "First Name");
	define("LAST_NAME_FIELD",    "Last Name");
	define("COMPANY_NAME_FIELD", "Company Name");
	define("EMAIL_FIELD",        "Email");
	define("STREET_FIRST_FIELD", "Street Address 1");
	define("STREET_SECOND_FIELD","Street Address 2");
	define("CITY_FIELD",         "City");
	define("PROVINCE_FIELD",     "Province");
	define("STATE_FIELD",        "State (for US only)");
	define("ZIP_FIELD",          "Zip/Postal Code");
	define("COUNTRY_FIELD",      "Country");
	define("PHONE_FIELD",        "Phone");
	define("DAYTIME_PHONE_FIELD","Daytime Phone");
	define("EVENING_PHONE_FIELD","Evening Phone");
	define("CELL_PHONE_FIELD",   "Cell phone");
	define("FAX_FIELD",          "Fax");

	// no records messages
	define("NO_EVENTS_MSG",      "No events were found");
	define("NO_QUESTIONS_MSG",   "No questions were found");
	define("NO_NEWS_MSG",        "No news articles were found");
 
?>