<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  user_home.php                                            ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include_once ("./messages/".$language_code."/cart_messages.php");
	include_once ("./messages/".$language_code."/support_messages.php");
	include_once ("./messages/".$language_code."/forum_messages.php");

	check_user_session();
	
	$operation = get_param("operation");

	if($operation == "logout") {
		set_session("session_user_id", "");
		set_session("session_user_login", "");
		set_session("session_user_name", "");
		header("Location: index.php");
		exit;
	}

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main", "user_home.html");
  $t->set_var("USER_HOME_TITLE", USER_HOME_TITLE);
  $t->set_var("CHANGE_DETAILS_MSG", CHANGE_DETAILS_MSG);
	$t->set_var("CHANGE_DETAILS_DESC", CHANGE_DETAILS_DESC);
  $t->set_var("CHANGE_PASSWORD_MSG", CHANGE_PASSWORD_MSG);
  $t->set_var("CHANGE_PASSWORD_DESC", CHANGE_PASSWORD_DESC);
  $t->set_var("MY_FORUM_TOPICS_MSG", MY_FORUM_TOPICS_MSG);
  $t->set_var("MY_FORUM_TOPICS_DESC", MY_FORUM_TOPICS_DESC);
  $t->set_var("MY_SUPPORT_ISSUES_MSG", MY_SUPPORT_ISSUES_MSG);
  $t->set_var("MY_SUPPORT_ISSUES_DESC", MY_SUPPORT_ISSUES_DESC);
  $t->set_var("MY_ORDERS_MSG", MY_ORDERS_MSG);
  $t->set_var("MY_ORDERS_DESC", MY_ORDERS_DESC);
  $t->set_var("LOGOUT_BUTTON", LOGOUT_BUTTON);

	$t->set_var("user_profile_href", "user_profile.php");
	$t->set_var("user_orders_href", "user_orders.php");
	$t->set_var("change_password_href", "change_password.php");
	$t->set_var("user_support_href", "user_support.php");
	$t->set_var("forum_href", "forum.php");

	$t->set_var("user_login", get_session("session_user_login"));
	$t->set_var("user_name", get_session("session_user_name"));

	include("./header.php");
	include("./footer.php");
	$t->pparse("main");

?>